--[[**************************************************
Licensed under the GNU General Public License version 2
(c) 2005 Carl J. Gruber
cgruber@hyperpixel.net
*************************************************]]
function Score()
green = rgb(0,255,0)
red = rgb(255,0,0)
drawText("Level:", 1,0, green)
drawText(level, 50,0, green)
drawText("Moves:", 100,0, green)
drawText(num_moves, 150,0,green)
drawText(os.date("!%c"), 320,0, green)
drawText("lsokoban for DJSP v 0.4 by Carl Gruber <cgruber@gmail.com>", 7,264, green)
end

function StartupPosition()
x=16 
y=8
clearScreen(rgb(0,0,0))
for i=0, 112 do
	if (i==1) then 
	      if (gamefield[i]==-1) then
				drawImage(player,16, 8)
				return i
				end
		elseif (i==15) then y=40 x=16
		elseif (i==29) then y=72 x=16
		elseif (i==43) then y=104 x=16
		elseif (i==57) then y=136 x=16
		elseif (i==71) then y=168 x=16
		elseif (i==85) then y=200 x=16
		elseif (i==99) then y=232 x=16
	end

	if (gamefield[i]== -1) then drawImage(player, x, y) return i end
x=x+32

end
end 
function DrawScreen()
x1=16 
y1=8
clearScreen(rgb(0,0,0))
for i=1, 112 do
	if (i==1) then 
	      if (gamefield[i]==1) then
				drawImage(block, 16, 8)
		  elseif (gamefield[i]==-2) then
			  drawImage(drop, 16,8)
		  elseif (gamefield[i]==3) then
			  drawImage(win, 16,8)
	  end
		elseif (i==15) then y1=40 x1=16
		elseif (i==29) then y1=72 x1=16
		elseif (i==43) then y1=104 x1=16
		elseif (i==57) then y1=136 x1=16
		elseif (i==71) then y1=168 x1=16
		elseif (i==85) then y1=200 x1=16
		elseif (i==99) then y1=232 x1=16
	end

	if (gamefield[i]== 1) then
		drawImage(block, x1, y1)
	elseif (gamefield[i] ==-2) then
		drawImage(drop, x1,y1)
	elseif (gamefield[i] == 2) then
		drawImage(stone, x1,y1)
	elseif (gamefield[i] == 3) then
	    drawImage(win, x1,y1)
	end
x1=x1+32

end

Score()
drawImage(player, x,y) 

flipScreen()
wait(50000)
end

function Move()
readControls()

if downPressed() then
	if(gamefield[mappos+14] < 1) then
	y=y+32
	mappos=mappos+14
	num_moves= num_moves+1
	
	elseif(gamefield[mappos+14]==2) then
	  if(gamefield[mappos+28]==0 or gamefield[mappos+28] ==-1)then
		mappos=mappos+14
		gamefield[mappos+14] = 2
		gamefield[mappos]=0
		y=y+32
		num_moves= num_moves+1
	  elseif(gamefield[mappos+28]==-2) then
		mappos=mappos+14
		gamefield[mappos+14]=3
		gamefield[mappos]=0
		y=y+32
		num_moves=num_moves+1
	  end
	elseif(gamefield[mappos+14]==3) then
	 if(gamefield[mappos+28]<1)then
		mappos=mappos+14
		if (gamefield[mappos+14] ~= -2) then
		gamefield[mappos+14] = 2
		else 
		gamefield[mappos+14]=3
		end 
		gamefield[mappos]=-2
		y=y+32
		num_moves= num_moves+1
	  end
	end
	
end

if upPressed() then
	if(gamefield[mappos-14] < 1) then
	y=y-32
	mappos=mappos-14
	num_moves= num_moves+1
	
	elseif(gamefield[mappos-14]==2) then
	  if(gamefield[mappos-28]==0 or gamefield[mappos-28] ==-1)then
		mappos=mappos-14
		gamefield[mappos-14] = 2
		gamefield[mappos]=0
		y=y-32
		num_moves= num_moves+1
	  elseif(gamefield[mappos-28]==-2) then
		mappos=mappos-14
		gamefield[mappos-14]=3
		gamefield[mappos]=0
		y=y-32
		num_moves=num_moves+1
	  end
	elseif(gamefield[mappos-14]==3) then
	 if(gamefield[mappos-28]<1)then
		mappos=mappos-14
		if (gamefield[mappos-14] ~= -2) then
		gamefield[mappos-14] = 2
		else 
		gamefield[mappos-14]=3
		end 
		gamefield[mappos]=-2
		y=y-32
		num_moves= num_moves+1
	  end
	end
	
end

if leftPressed() then
   if(gamefield[mappos-1] < 1) then
	x=x-32
	mappos=mappos-1
	num_moves= num_moves+1
	
	elseif(gamefield[mappos-1]==2) then
	  if(gamefield[mappos-2]==0 or gamefield[mappos-2] ==-1)then
		mappos=mappos-1
		gamefield[mappos-1] = 2
		gamefield[mappos]=0
		x=x-32
		num_moves= num_moves+1
	  elseif(gamefield[mappos-2]==-2) then
		mappos=mappos-1
		gamefield[mappos-1]=3
		gamefield[mappos]=0
		x=x-32
		num_moves=num_moves+1
	  end
	elseif(gamefield[mappos-1]==3) then
	 if(gamefield[mappos-2]<1)then
		mappos=mappos-1
		if (gamefield[mappos-1] ~= -2) then
		gamefield[mappos-1] = 2
		else 
		gamefield[mappos-1]=3
		end 
		gamefield[mappos]=-2
		x=x-32
		num_moves= num_moves+1
	  end
	end
end

if rightPressed() then
   if(gamefield[mappos+1] < 1) then
	x=x+32
	mappos=mappos+1
	num_moves= num_moves+1
	
	elseif(gamefield[mappos+1]==2) then
	  if(gamefield[mappos+2]==0 or gamefield[mappos+2] ==-1)then
		mappos=mappos+1
		gamefield[mappos+1] = 2
		gamefield[mappos]=0
		x=x+32
		num_moves= num_moves+1
	  elseif(gamefield[mappos+2]==-2) then
		mappos=mappos+1
		gamefield[mappos+1]=3
		gamefield[mappos]=0
		x=x+32
		num_moves=num_moves+1
	  end
	elseif(gamefield[mappos+1]==3) then
	 if(gamefield[mappos+2]<1)then
		mappos=mappos+1
		if (gamefield[mappos+1] ~= -2) then
		gamefield[mappos+1] = 2
		else 
		gamefield[mappos+1]=3
		end 
		gamefield[mappos]=-2
		x=x+32
		num_moves= num_moves+1
	  end
	end
end

if rtriggerPressed() then
	level=level+1
	wait(1000000)
	LoadLevel(level)
end

if ltriggerPressed() then
	if (level==1) then
		wait(1000000)
		LoadLevel(level)
	else
		level = level -1
		wait(1000000)
		LoadLevel(level)
	end
end

if crossPressed() then
		return 1
end 

end
function LevelComplete()
for i=1, 112 do
	if(gamefield[i]==-2) then return 0	end
end
wait(1000000)
level=level+1
return 1 --nothing found we won
end

function LoadLevel()
if (level>4) then level=1 end
if (level == 1) then 
 gamefield = { 0,0,1,1,1,1,1,1,1,0,0,0,0,0,
			  0,0,1,-1,0,0,0,0,1,1,1,0,0,0,
			  1,1,1,0,0,0,2,0,0,0,1,0,0,0,
			  1,0,0,0,0,1,0,1,0,0,1,1,1,1,
			  1,0,2,1,0,0,1,0,0,0,0,0,0,1,
			  1,1,0,0,2,0,0,0,0,0,0,0,-2,1,
			  0,1,0,0,0,0,0,0,0,0,1,-2,-2,1,
			  0,1,1,1,1,1,1,1,1,1,1,1,1,1 }
elseif (level == 2) then
gamefield = { 0,0,0,0,0,1,1,1,1,0,0,0,0,0,
			  0,0,0,0,0,1,-2,2,1,0,0,0,0,0,
			  0,0,0,1,1,1,0,0,1,1,1,0,0,0,
			  0,0,0,1,-2,2,2,2,2,-2,1,0,0,0,
			  0,0,0,1,-2,2,0,0,2,-2,1,0,0,0,
			  0,0,0,1,1,1,2,0,1,1,1,0,0,0,
			  0,0,0,0,0,1,-1,-2,1,0,0,0,0,0,
			  0,0,0,0,0,1,1,1,1,0,0,0,0,0 }
elseif (level==3) then
gamefield = { 0,0,0,0,1,1,1,1,1,1,0,0,0,0,
			  0,0,0,1,-2,2,0,0,0,0,1,0,0,0,
			  0,0,1,-2,0,2,2,0,2,0,0,1,0,0,
			  0,0,1,-2,0,0,1,1,0,0,-1,1,0,0,
			  0,0,1,-2,0,0,1,1,0,0,0,1,0,0,
			  0,0,1,-2,0,2,0,2,2,0,0,1,0,0,
			  0,0,0,1,-2,0,0,0,2,0,1,0,0,0,
			  0,0,0,0,1,1,1,1,1,1,0,0,0 }
elseif (level==4) then
gamefield = { 1,1,1,1,1,1,1,1,1,1,1,1,1,1,
			  1,0,2,0,2,0,2,0,2,0,2,0,2,1,
			  1,2,0,2,0,2,1,1,1,2,0,2,0,1,
			  1,0,2,0,2,0,-2,-2,2,0,2,0,2,1,
			  1,2,0,2,0,2,-2,-2,0,2,0,2,0,1,
			  1,0,2,0,2,1,1,1,2,0,2,0,2,1,
			  1,-1,0,2,0,2,0,2,0,2,0,2,0,1,
			  1,1,1,1,1,1,1,1,1,1,1,1,1,1, }
end
mappos = StartupPosition()
num_moves=0
end


--Game Inits
--dofile("levels/1.lua")
disableDJSPControls()
useFlipScreen(true)
gamefield={}
x=0 y=0
mappos=0 num_moves=0
level=1
block = loadImage("block.png")
player = loadImage("player.png")
drop = loadImage("drop.png")
stone = loadImage("stone.png")
win = loadImage("win.png")
LoadLevel(1)

mappos = StartupPosition()

while not false do --game loop

if (Move()==1) then break end  --if start is pressed quit
DrawScreen()
if (LevelComplete()==1) then 
	LoadLevel(level)
end
end

